#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <iomanip>

using namespace std;
typedef long long ll;
string form(string s) {
	string ans;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == 'X') ans.push_back('1');
		else ans.push_back('0');
	}
	return ans;
}
int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // _DEBUG

	int n, m; cin >> n >> m;
	vector<vector<int>> right(n, vector<int>(3)), left(n, vector<int>(3));
	for (int i = 0; i < n; i++) {
		string s; cin >> s;
		s = form(s);
		right[i][0] = s[0] - '0';
		right[i][1] = s[1] - '0';
		right[i][2] = s[2] - '0';
		left[i][0] = s[5] - '0';
		left[i][1] = s[4] - '0';
		left[i][2] = s[3] - '0';
	}

	//for (int i = 0; i < n; i++) {
	//	for (auto j : right[i]) cout << j << " ";
	//	for (auto j : left[i]) cout << j << " ";
	//	cout << '\n';
	//}
	//cout << '\n';
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 3; j++) {
			if (right[i][j] == left[i][j]) continue;
			if (right[i][j] == 1) {
				if (m == 0) {
					cout << "Impossible";
					return 0;
				}
				left[i][j] = 1;
				m--;
			}
			else if (left[i][j] == 1) {
				if (m == 0) {
					cout << "Impossible";
					return 0;
				}
				right[i][j] = 1;
				m--;
			}
		}
	}
	bool flag = m == 0;
	for (int i = 0; i < n; i++) {
		if (flag) break;
		for (int j = 0; j < 3; j++) {
			if (right[i][j] == 0 && left[i][j] == 0) {
				if (m == 1) {
					cout << "Impossible";
					return 0;
				}
				else if (m != 0) {
					left[i][j] = 1;
					right[i][j] = 1;
					m -= 2;
				}

			}
		}
	}
	if (m != 0)cout << "Impossible";
	else {
		for (int i = 0; i < n; i++) {
			for (auto j : right[i]) cout << (j == 1 ? "X" : ".");
			for (int j = 2; j >= 0; j--) cout << (left[i][j] == 1 ? "X" : ".");
			cout << '\n';
		}
	}


}



