#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <iomanip>

using namespace std;
typedef long long ll;
ll count(int l, int r) {
	ll ans = 0, diff = r - l;
	while (diff != 0) {
		ans += diff; diff--;
	}
	return ans;
}


int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // _DEBUG

	int n; cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];


	int l = 0, r = 1;
	bool going = false;// false - up true - down
	ll ans = 0;
	while (r != a.size()) {
		if (a[r - 1] < a[r]) {
			if (!going) r++;
			else {
				ans += count(l, r);
				l = r;
				r++;
				going = false;
			}
		}
		else if (a[r - 1] > a[r]) {
			r++;
			going = true;
		}
		else if (a[r - 1] == a[r]) {
			ans += count(l, r);
			l = r;
			r++;
			going = false;
		}
	}
	ans += count(l, r);
	cout << ans;


}



