#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>

using namespace std;
typedef long long ll;

ll ans, n;
set<vector<pair<int, int>>> st;

// 1= 5 5 5    ||| 2 = 2 3 4
void rec(vector<int> numbers, vector<pair<int, int>> operations) {
	if (operations.size() * 3 == n) {
		sort(operations.begin(), operations.end());
		if (st.find(operations) == st.end()) ans += 1;
		st.insert(operations);
		ans %= (ll)1e9 + 7;
		return;
	}

	for (int i = 0; i < numbers.size(); i++) {
		if (numbers[i] >= 3) {
			numbers[i] -= 3;
			operations.push_back({ 1,i });
			rec(numbers, operations);
			numbers[i] += 3;
			operations.pop_back();
		}
	}
	for (int i = 0; i < numbers.size() - 2; i++) {
		if (numbers[i] >= 1 && numbers[i + 1] >= 1 && numbers[i + 2] >= 1) {
			numbers[i]--; numbers[i + 1]--; numbers[i + 2]--;
			operations.push_back({ 2,i });
			rec(numbers, operations);
			numbers[i]++; numbers[i + 1]++; numbers[i + 2]++;
			operations.pop_back();
		}
	}



}
int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // 
	int m;
	cin >> n >> m;
	ans = 0;
	vector<int> unwrapped(n);
	int mx = -1;
	for (int i = 0; i < n; i++) {
		cin >> unwrapped[i];
	}
	vector<int> a(m + 1);
	for (auto i : unwrapped)a[i]++;
	vector<pair<int, int>> operations;
	rec(a, operations);
	cout << ans;

}