#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>

using namespace std;
typedef long long ll;

ll ans, n;

const int INF = 1e9 + 7;
bool check(vector<int> trk) {
	for (int i = 0; i < trk.size(); i++) {
		while (trk[i] >= 3)trk[i] -= 3;
	}
	for (int i = 0; i < trk.size() - 2; i++) {
		if (trk[i] > 0 && trk[i + 1] > 0 && trk[i + 2] > 0) {
			while (trk[i] != 0 && trk[i + 1] != 0 && trk[i + 2] != 0) {
				trk[i]--; trk[i + 1]--; trk[i + 2]--;
			}
		}
	}
	for (int i = 0; i < trk.size(); i++) {
		if (trk[i] == 1) return false;
	}
	return true;
}
int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // 
	int m;
	cin >> n >> m;
	ans = 0;
	vector<int> unwrapped(n);
	int mx = -1;
	for (int i = 0; i < n; i++) {
		cin >> unwrapped[i];
	}
	vector<int> a(m + 1);
	for (auto i : unwrapped)a[i]++;
	if (!check(a)) {
		cout << 0; return 0;
	}
	vector<int> troika(m + 1);
	for (int i = 0; i <= m; i++) {
		while (a[i] >= 3) {
			a[i] -= 3;
			troika[i]++;
		}
	}
	//0 - 2 2 2 ||| 1 - 3 4 5
	vector<vector<int>> dp(m + 1, vector<int>(2));
	dp[0][0] = 1;
	dp[1][0] = 1;

	for (int i = 2; i <= m; i++) {
		dp[i][0] = max(dp[i - 1][0], dp[i - 1][1]);
		if (troika[i] && troika[i - 1] && troika[i - 2])dp[i][1] = (dp[i - 2][0] * (1+min({ troika[i],troika[i - 1],troika[i - 2] }))) % INF;

	}
	cout << max(dp[m][0], dp[m][1]);



}