#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <iomanip>
#include <cstdlib>

using namespace std;
typedef long long ll;

ll sum, n, m;
vector<vector<ll>> tablet;
vector<int> usedstolb, usedstr;
vector<pair<int, int>> operations;


ll mns(ll type, ll id) {
	ll ans = 0;
	if (type == 1) {
		for (int i = 0; i < m; i++) {
			if (!usedstolb[i])
				ans += tablet[id][i];
		}
	}
	if (type == 2) {
		for (int i = 0; i < n; i++) {
			if (!usedstr[i])
				ans += tablet[i][id];
		}
	}
	return ans;
}

void fun(ll nowsum) {
	if (nowsum < sum) return;
	else if (nowsum == sum) {
		cout << "YES\n" << operations.size() << '\n';
		for (auto i : operations) {
			cout << i.first << " " << i.second + 1 << '\n';
		}
		exit(0);
	}

	for (ll i = 0; i < n; i++) {
		if (usedstr[i]) continue;

		usedstr[i] = 1;

		ll newsum = nowsum - mns(1, i);
		operations.push_back({ 1,i });
		fun(newsum);
		operations.pop_back();
		usedstr[i] = 0;
	}
	for (ll i = 0; i < m; i++) {
		if (usedstolb[i]) continue;

		usedstolb[i] = 1;

		ll newsum = nowsum - mns(2, i);
		operations.push_back({ 2, i });

		fun(newsum);

		operations.pop_back();
		usedstolb[i] = 0;

	}
}

int main() {
	//ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // _DEBUG
	cin >> n >> m;
	tablet.resize(n, vector<ll>(m));
	usedstolb.resize(m);
	usedstr.resize(n);
	ll nowSum = 0;
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> tablet[i][j];
			nowSum += tablet[i][j];
		}
	}
	cin >> sum;
	if (sum > nowSum) {
		cout << "NO";
		return 0;
	}
	fun(nowSum);
	cout << "NO";



}



