#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>

using namespace std;
typedef long long ll;
vector<int> findAllPrime(int n) {
	vector<int> ans(n + 1);
	ans[0] = 1; ans[1] = 1;
	for (int i = 2; i <= n; i++) {
		if (ans[i])continue;
		for (int j = 2 * i; j <= n; j += i) {
			ans[j] = 1;
		}

	}
	return ans;
}
set<int> countBad(vector<int>&prime, int a) {
	set<int> ans;
	for (int i = 1; i*i <= a; i++) {
		if (a%i == 0 && !prime[a / i])ans.insert(i);
	}
	return ans;
}
int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // 





	int n; cin >> n;

	vector<int> a(n);
	vector<int> primes = findAllPrime(1e6);
	map<int, set<int>> mp;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mp[a[i]] = countBad(primes, a[i]);
	}
	set<int> bad1;
	vector<int> badNums1, badNums2;//ID
	for (int i = 0; i < n; i++) {
		if (bad1.find(a[i]) != bad1.end()) {
			badNums2.push_back(i);
			continue;
		}
		bool flag = false;
		for (auto j : badNums1) {
			if (mp[a[i]].find(a[j]) != mp[a[i]].end()) {
				badNums2.push_back(i);
				flag = true;
				break;
			}
		}
		if (flag) continue;
		badNums1.push_back(i);
		for (auto i : mp[a[i]]) {
			bad1.insert(i);
		}
	}
	for (auto i : badNums1) {
		a[i] = 1;
	}
	for (auto j : badNums2) {
		a[j] = 2;
	}
	for (auto i : a) {
		cout << i << " ";
	}

}