#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>

using namespace std;
typedef long long ll;


int count(int a, int del) {
	int ans = 0;
	while (a != 1) {
		a /= del;
		ans++;
	}
	return ans;
}




vector<int> findAllPrime(int n) {
	vector<int> ans(n + 1);
	ans[0] = 1; ans[1] = 1;
	for (int i = 2; i <= n; i++) {
		if (ans[i])continue;
		for (int j = 2 * i; j <= n; j += i) {
			ans[j] = 1;
		}

	}
	return ans;
}
set<int> countBad(vector<int>&prime, int a) {
	set<int> ans;
	for (int i = 1; i*i <= a; i++) {
		if (a%i == 0 && !prime[a / i])ans.insert(i);
	}
	return ans;
}
int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // 
	int n; cin >> n;
	bool flag = true;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] > 4) flag = false;
	}
	if (flag) {
		//1 4, 2 3
		for (int i = 0; i < n; i++) {
			if (a[i] == 1 || a[i] == 4) a[i] = 1;
			else a[i] = 2;
		}
		for (auto i : a) {
			cout << i << " ";
		}
	}
	else if (a.size() < 11) {
		vector<int> prime = findAllPrime(1e6);
		vector<int> com1, com2;
		for (int i = 0; i < n; i++) {
			bool f = false;
			for (int j = 0; j < com1.size(); j++) {
				int mn = min(a[com1[j]], a[i]), mx = max(a[com1[j]], a[i]);
				if (mx%mn == 0 && !prime[mx / mn]) {
					f = true;
					com2.push_back(i);
				}
			}
			if (f) continue;

			com1.push_back(i);
		}

		for (auto i : com1)a[i] = 1;
		for (auto i : com2)a[i] = 2;

		for (auto i : a) {
			cout << i << " ";
		}
	}
	else {
		int del = 1;
		int numCheck = a[0];
		for (int i = 0; i < n; i++) {
			numCheck = a[i];
			if (numCheck != 1) break;
		}
		for (int i = 2; i*i <= numCheck; i++) {
			if (numCheck%i == 0) {
				del = i;
				break;
			}
		}
		for (int i = 0; i < n; i++) {
			a[i] = count(a[i], del);
			if (a[i] % 2 == 1) a[i] = 2;
			else a[i] = 1;
		}
		for (auto i : a) {
			cout << i << " ";
		}
		

	}






}