#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>

using namespace std;
typedef long long ll;
bool globalFlag = false;
ll fastPow(ll a, ll x) {

	if (x == 0) return 1;
	if (x % 2 == 0) {
		ll f = fastPow(a, x / 2);
		if (f*f >= 1e9 || f > 1e9 || f == -1) return -1;
		return f * f;
	}
	else {
		int f = fastPow(a, x - 1);
		if (f == -1 || f > 1e9) return -1;
		return f * a;
	}
}
bool check(vector<ll>& drop, vector<ll>& grow, ll time, ll need) {
	ll nowBac = 0;
	for (ll i = 0; i < drop.size(); i++) {

		if (nowBac >= need) {
			if (nowBac == need) globalFlag = true;
			return true;
		}

		ll nowtime = time;
		nowtime -= drop[i];

		if (nowtime < 0) continue;

		nowBac++;
		nowtime -= grow[i];

		if (nowtime < 0) continue;

		nowBac--;
		ll bc = fastPow(2, nowtime + 1);

		if (bc == -1) return true;
		nowBac += bc;
	}
	if (nowBac == need) globalFlag = true;
	if (nowBac >= need) return true;
	else return false;
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // 

	ll n, need; cin >> n >> need;
	vector<ll> dropTime(n), growTime(n);

	for (ll i = 0; i < n; i++) {
		cin >> dropTime[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> growTime[i];
	}
	ll now;

	ll l = -1, r = 1e9, m;

	while (r - l > 1) {
		ll m = (r + l) / 2;
		if (check(dropTime, growTime, m, need))r = m;
		else l = m;
	}
	if (globalFlag) cout << r;
	else cout << -1 << " " << r;
}